//Function to set fuses
byte lfuse, hfuse, actual_lfuse, actual_hfuse;

void commandLine(){
  uint16_t sig;
  byte a, b, choice, ch;

  if (!pmode) {
    Serial.println(F("Entering HV Programming Mode"));
    start_pmode();
  }
  sig = find_signature();
  Serial.print(" Signature is: 0x");
  Serial.print(sig, HEX);
  if(sig==ATTINY13) Serial.println(F(" = ATTINY13 "));
  else if(sig==ATTINY25) Serial.println(F(" = ATTINY25 "));
  else if(sig==ATTINY45) Serial.println(F(" = ATTINY45 "));
  else if(sig==ATTINY85) Serial.println(F(" = ATTINY85 "));
  else Serial.println(F(" , NOT A VALID SIGNATURE "));
  
while(1) {
  Serial.println(F("Please choose r(ead fuses),h(fuse mod), l(fuse mod), P(rogram), E(rase), X(eXit)"));  
  choice = getSerialChar();
  switch(choice) {
    case 'E':
      Serial.println(F(" ERASING CHIP"));
      chipErase();
      break;
    case 'r':
      Serial.println(F(" actual fuses are:"));
      readFusesHV();
      Serial.print(F(" hfuse = 0x"));
      Serial.print(actual_hfuse, HEX);
      Serial.print(F(" = 0b"));
      Serial.print(actual_hfuse, BIN);
      if (sig == ATTINY13 && actual_hfuse!=0xFF) Serial.println(F(" , NOT DEFAULT = OxFF"));
      else if(actual_hfuse!=0xDF) Serial.println(F(" NOT DEFAULT = OxDF"));
      Serial.print(F(" lfuse = 0x"));
      Serial.print(actual_lfuse, HEX);
      Serial.print(F(" = 0b"));
      Serial.print(actual_lfuse, BIN);
      if (sig == ATTINY13 && actual_lfuse!=0x6A) Serial.println(F(" , NOT DEFAULT = Ox6A"));
      else if(actual_lfuse!=0x62) Serial.println(F(" NOT DEFAULT = Ox62"));
      break;
    case 'X':
      Serial.println(F(" stopping HV program mode"));
      end_pmode();
      Serial.println(F(" Exit"));
      return;
    case 'h':
    case 'l':
      // first set fuses at actual values
      readFusesHV();
      hfuse= actual_hfuse;
      lfuse= actual_lfuse;
      Serial.print(F("\n\r you choose "));
      Serial.write(choice);
      Serial.println(F("-fuse, now enter 2 hexadecimal characters"));
      while (Serial.available()<2) {}
      a=Serial.read();
      b=Serial.read();
      if(!isHexadecimalDigit(a) || !isHexadecimalDigit(b)) {
        Serial.println(F(" not an hexadecimal number"));
        break;
      }  
      else {
        Serial.print(F("elected "));
        Serial.write(choice);
        ch=ahex2int(a,b);
        Serial.print(F("-fuse= 0x"));
        Serial.print(ch,HEX);
        Serial.print(F(" = 0b"));
        Serial.println(ch,BIN);
      }
      if(choice=='h') hfuse=ch;
      if(choice=='l') lfuse=ch;
      break;
    case'P':
      Serial.println(F("you want to program the fuses to:"));
      Serial.print(F(" hfuse = 0x"));
      Serial.print(hfuse, HEX);
      Serial.print(F(" = 0b"));
      Serial.println(hfuse, BIN);
      Serial.print(F(" lfuse = 0x"));
      Serial.print(lfuse, HEX);
      Serial.print(F(" = 0b"));
      Serial.println(lfuse, BIN);
      Serial.println(F("\n\r are you OK with this ? (Y/N)"));
      choice = getSerialChar();
      while (choice!= 'Y' && choice!='N');
      if(choice== 'Y') {
        Serial.println(" WRITING FUSES");
        writeFusesHV(lfuse, hfuse);
      }
      break;
  }
}    

}

void writeFusesHV(byte _l, byte _h){
  Serial.print("Writing hfuse = ");
  Serial.println(_h, BIN);
  writeHV(0x40, 0x4C);
  writeHV(_h, 0x2C);
  writeHV(0x00, 0x74);
  writeHV(0x00, 0x7C);
  //Write lfuse
  Serial.print("Writing lfuse = ");
  Serial.println(_l, BIN);
  writeHV(0x40, 0x4C);
  writeHV(_l, 0x2C);
  writeHV(0x00, 0x64);
  writeHV(0x00, 0x6C);
  Serial.println(); 
}

void readFusesHV(){
  writeHV(0x04, 0x4C);
  writeHV(0x00, 0x7A);
  actual_hfuse = writeHV(0x00, 0x7E);
  writeHV(0x04, 0x4C);
  writeHV(0x00, 0x68);
  actual_lfuse = writeHV(0x00, 0x6C);
}

uint16_t find_signature () {
//unsigned int find_signature () {
  uint16_t sig = 0;
//  unsigned int sig = 0;
  byte val;
  for (int ii = 1; ii < 3; ii++) {
    writeHV(0x08, 0x4C);
    writeHV(  ii, 0x0C);
    writeHV(0x00, 0x68);
    val = writeHV(0x00, 0x6C);

    sig = (sig << 8) + val;
  }
  return sig;
}

void chipErase () {
  writeHV(0b10000000, 0b01001100);
  writeHV(0b00000000, 0b01100100);
  writeHV(0b00000000, 0b01101100);
}

// makes a number from two ascii hexa characters
int ahex2int(char a, char b){
    a = (a <= '9') ? a - '0' : (a & 0x7) + 9;
    b = (b <= '9') ? b - '0' : (b & 0x7) + 9;
    return (a << 4) + b;
}
