//Functions to enter / exit HV programming mode

void start_pmode() {
  if (!pmode){
    pinMode(SDO, OUTPUT);
    digitalWrite(SDI, LOW);
    digitalWrite(SII, LOW);
    digitalWrite(SDO, LOW);
    digitalWrite(VCC, HIGH);  // Vcc On
    delayMicroseconds(200);
    // switching 12v On
    digitalWrite(HV, HIGH);
    TIMSK2 = 1; // timer2 overflow interrupt enabled
    delayMicroseconds(200); //(10);
    digitalWrite(RST, HIGH); // led when HV present
    pinMode(SDO, INPUT);
    delayMicroseconds(300);
    //HVP mode entered.  Now command Flash Writing
    pmode = 1;
  }
}


void end_pmode() {
  if (pmode){
    // switching 12v Off
    digitalWrite(HV, 0);
    TIMSK2 = 0; // timer2 overflow interrupt disabled
    delay(1000); // wait for HV to decrease
    digitalWrite(RST, 0); //led off when HV disappears
    digitalWrite(VCC, LOW);    // Vcc Off
    pinMode(SDO, OUTPUT);
    pmode = 0;
  }
}
