//Basic HV Serial Communication with ATTINY

byte writeHV(byte sdiByte, byte siiByte){
  byte in = 0;
  while (!digitalRead(SDO)){};
  digitalWrite(SDI, 0);
  digitalWrite(SII, 0);
  in = pulseClock();
  for (byte i = 0; i < 8; i++){
    digitalWrite(SDI, ((sdiByte >> (7-i)) & 1));
    digitalWrite(SII, ((siiByte >> (7-i)) & 1));
    if (i < 7){
      in = in << 1;
      in |= pulseClock();
    }
    else pulseClock();
  }
  digitalWrite(SDI, 0);
  digitalWrite(SII, 0);
  pulseClock();
  pulseClock();
  return in;
}

bool pulseClock(){
  delayMicroseconds(8); //This only needs to be <1 microsecond, but let's just play things safe :)
  digitalWrite(SCI, 1);
  delayMicroseconds(8); //Same...
  byte in = digitalRead(SDO); //Reading back from target
  digitalWrite(SCI, 0);
  return in;
}

byte shiftOut (byte val1, byte val2) {
  int inBits = 0;
  //Wait until SDO goes high
  while (!digitalRead(SDO))
    ;
  unsigned int dout = (unsigned int) val1 << 2;
  unsigned int iout = (unsigned int) val2 << 2;
  for (int ii = 10; ii >= 0; ii--)  {
    digitalWrite(SDI, !!(dout & (1 << ii)));
    digitalWrite(SII, !!(iout & (1 << ii)));
    inBits <<= 1;
    inBits |= digitalRead(SDO);
    digitalWrite(SCI, HIGH);
    digitalWrite(SCI, LOW);
  }
  return inBits >> 2;
}
